diff --git a/src/test/obj_tx_strdup/TEST0 b/src/test/obj_tx_strdup/TEST0
index 524c268a86f..698d93ceffc 100755
--- a/src/test/obj_tx_strdup/TEST0
+++ b/src/test/obj_tx_strdup/TEST0
@@ -42,7 +42,7 @@ configure_valgrind pmemcheck force-disable
 
 setup
 
-expect_normal_exit ./obj_tx_strdup$EXESUFFIX $DIR/testfile1
+expect_normal_exit ./obj_tx_strdup$EXESUFFIX $DIR/testfile1 t
 
 check
 
diff --git a/src/test/obj_tx_strdup/TEST0.PS1 b/src/test/obj_tx_strdup/TEST0.PS1
index 15d472c0fd3..db82001dff1 100644
--- a/src/test/obj_tx_strdup/TEST0.PS1
+++ b/src/test/obj_tx_strdup/TEST0.PS1
@@ -1,5 +1,5 @@
 #
-# Copyright 2015-2019, Intel Corporation
+# Copyright 2015-2020, Intel Corporation
 # Copyright (c) 2016, Microsoft Corporation. All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without
@@ -41,7 +41,7 @@ require_test_type medium
 
 setup
 
-expect_normal_exit $Env:EXE_DIR\obj_tx_strdup$Env:EXESUFFIX $DIR\testfile1
+expect_normal_exit $Env:EXE_DIR\obj_tx_strdup$Env:EXESUFFIX $DIR\testfile1 t
 
 check
 
diff --git a/src/test/obj_tx_strdup/TEST1 b/src/test/obj_tx_strdup/TEST1
index d3b7cdab048..d0b79a8c7a6 100755
--- a/src/test/obj_tx_strdup/TEST1
+++ b/src/test/obj_tx_strdup/TEST1
@@ -1,6 +1,6 @@
 #!/usr/bin/env bash
 #
-# Copyright 2015-2019, Intel Corporation
+# Copyright 2015-2020, Intel Corporation
 #
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions
@@ -43,7 +43,7 @@ require_fs_type any
 configure_valgrind pmemcheck force-enable
 setup
 
-expect_normal_exit ./obj_tx_strdup$EXESUFFIX $DIR/testfile1
+expect_normal_exit ./obj_tx_strdup$EXESUFFIX $DIR/testfile1 t
 
 check
 
diff --git a/src/test/obj_tx_strdup/TEST2 b/src/test/obj_tx_strdup/TEST2
new file mode 100755
index 00000000000..90f09c26f19
--- /dev/null
+++ b/src/test/obj_tx_strdup/TEST2
@@ -0,0 +1,50 @@
+#!/usr/bin/env bash
+#
+# Copyright 2015-2020, Intel Corporation
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+#     * Redistributions of source code must retain the above copyright
+#       notice, this list of conditions and the following disclaimer.
+#
+#     * Redistributions in binary form must reproduce the above copyright
+#       notice, this list of conditions and the following disclaimer in
+#       the documentation and/or other materials provided with the
+#       distribution.
+#
+#     * Neither the name of the copyright holder nor the names of its
+#       contributors may be used to endorse or promote products derived
+#       from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+#
+# src/test/obj_tx_strdup/TEST2 -- unit test for pmemobj_tx_strdup
+#
+
+. ../unittest/unittest.sh
+
+require_test_type medium
+require_build_type debug
+require_fs_type pmem
+configure_valgrind pmemcheck force-enable
+setup
+
+expect_normal_exit ./obj_tx_strdup$EXESUFFIX $DIR/testfile1 f
+
+check
+
+pass
diff --git a/src/test/obj_tx_strdup/obj_tx_strdup.c b/src/test/obj_tx_strdup/obj_tx_strdup.c
index ccdf6c6137e..49a0aa4a987 100644
--- a/src/test/obj_tx_strdup/obj_tx_strdup.c
+++ b/src/test/obj_tx_strdup/obj_tx_strdup.c
@@ -1,5 +1,5 @@
 /*
- * Copyright 2015-2019, Intel Corporation
+ * Copyright 2015-2020, Intel Corporation
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -32,6 +32,11 @@
 
 /*
  * obj_tx_strdup.c -- unit test for pmemobj_tx_strdup
+ *
+ * usage: obj_tx_strdup file operation:...
+ *
+ * operations are 't' or 'f'
+ *
  */
 #include <sys/param.h>
 #include <string.h>
@@ -405,10 +410,10 @@ do_tx_strdup_noflush(PMEMobjpool *pop)
 {
 	TX_BEGIN(pop) {
 		errno = 0;
-		pmemobj_tx_xstrdup(TEST_STR_1, TYPE_NOFLUSH,
-				POBJ_XALLOC_NO_FLUSH);
-		pmemobj_tx_xwcsdup(TEST_WCS_1, TYPE_WCS_NOFLUSH,
-				POBJ_XALLOC_NO_FLUSH);
+			pmemobj_tx_xstrdup(TEST_STR_1, TYPE_NOFLUSH,
+					POBJ_XALLOC_NO_FLUSH);
+			pmemobj_tx_xwcsdup(TEST_WCS_1, TYPE_WCS_NOFLUSH,
+					POBJ_XALLOC_NO_FLUSH);
 	} TX_ONCOMMIT {
 		UT_ASSERTeq(errno, 0);
 	} TX_ONABORT {
@@ -421,26 +426,27 @@ main(int argc, char *argv[])
 {
 	START(argc, argv, "obj_tx_strdup");
 
-	if (argc != 2)
-		UT_FATAL("usage: %s [file]", argv[0]);
+	if (argc != 3)
+		UT_FATAL("usage: %s [file] op:t|f", argv[0]);
 
 	PMEMobjpool *pop;
 	if ((pop = pmemobj_create(argv[1], LAYOUT_NAME, PMEMOBJ_MIN_POOL,
 	    S_IWUSR | S_IRUSR)) == NULL)
 		UT_FATAL("!pmemobj_create");
 
-	for (counter = 0; counter < MAX_FUNC; counter++) {
-		do_tx_strdup_commit(pop);
-		do_tx_strdup_abort(pop);
-		do_tx_strdup_null(pop);
-		do_tx_strdup_free_commit(pop);
-		do_tx_strdup_free_abort(pop);
-		do_tx_strdup_commit_nested(pop);
-		do_tx_strdup_abort_nested(pop);
-		do_tx_strdup_abort_after_nested(pop);
-	}
-
-	do_tx_strdup_noflush(pop);
+	if (strcmp(argv[2], "t") == 0) {
+		for (counter = 0; counter < MAX_FUNC; counter++) {
+			do_tx_strdup_commit(pop);
+			do_tx_strdup_abort(pop);
+			do_tx_strdup_null(pop);
+			do_tx_strdup_free_commit(pop);
+			do_tx_strdup_free_abort(pop);
+			do_tx_strdup_commit_nested(pop);
+			do_tx_strdup_abort_nested(pop);
+			do_tx_strdup_abort_after_nested(pop);
+		}
+	} else if (strcmp(argv[2], "f") == 0)
+		do_tx_strdup_noflush(pop);
 
 	pmemobj_close(pop);
 
diff --git a/src/test/obj_tx_strdup/out0.log.match b/src/test/obj_tx_strdup/out0.log.match
index f7c5cc165f3..52cee420eaa 100644
--- a/src/test/obj_tx_strdup/out0.log.match
+++ b/src/test/obj_tx_strdup/out0.log.match
@@ -1,3 +1,3 @@
 obj_tx_strdup$(nW)TEST0: START: obj_tx_strdup
- $(nW)obj_tx_strdup$(nW) $(nW)testfile1
+ $(nW)obj_tx_strdup$(nW) $(nW)testfile1 t
 obj_tx_strdup$(nW)TEST0: DONE
diff --git a/src/test/obj_tx_strdup/out1.log.match b/src/test/obj_tx_strdup/out1.log.match
index 6b201586961..6c04043a7af 100644
--- a/src/test/obj_tx_strdup/out1.log.match
+++ b/src/test/obj_tx_strdup/out1.log.match
@@ -1,3 +1,3 @@
 obj_tx_strdup$(nW)TEST1: START: obj_tx_strdup
- $(nW)obj_tx_strdup$(nW) $(nW)testfile1
+ $(nW)obj_tx_strdup$(nW) $(nW)testfile1 t
 obj_tx_strdup$(nW)TEST1: DONE
diff --git a/src/test/obj_tx_strdup/out2.log.match b/src/test/obj_tx_strdup/out2.log.match
new file mode 100644
index 00000000000..3841339acb5
--- /dev/null
+++ b/src/test/obj_tx_strdup/out2.log.match
@@ -0,0 +1,3 @@
+obj_tx_strdup$(nW)TEST2: START: obj_tx_strdup
+ $(nW)obj_tx_strdup$(nW) $(nW)testfile1 f
+obj_tx_strdup$(nW)TEST2: DONE
diff --git a/src/test/obj_tx_strdup/pmemcheck1.log.match b/src/test/obj_tx_strdup/pmemcheck1.log.match
index 8805445e149..5f1e67a8900 100644
--- a/src/test/obj_tx_strdup/pmemcheck1.log.match
+++ b/src/test/obj_tx_strdup/pmemcheck1.log.match
@@ -5,27 +5,5 @@
 ==$(*)== Parent PID: $(*)
 ==$(*)== 
 ==$(*)== 
-==$(*)== Number of stores not made persistent: 2
-==$(*)== Stores not made persistent properly:
-==$(*)== [0]    at 0x$(*): __memcpy$(*)
-==$(*)==    by 0x$(*): constructor_tx_alloc (tx.c:$(*))
-==$(*)==    by 0x$(*): alloc_prep_block (palloc.c:$(*))
-==$(*)==    by 0x$(*): palloc_reservation_create (palloc.c:$(*))
-==$(*)==    by 0x$(*): palloc_reserve (palloc.c:$(*))
-==$(*)==    by 0x$(*): tx_alloc_common (tx.c:$(*))
-==$(*)==    by 0x$(*): pmemobj_tx_xstrdup (tx.c:$(*))
-==$(*)==    by 0x$(*): do_tx_strdup_noflush (obj_tx_strdup.c:$(*))
-==$(*)==    by 0x$(*): main (obj_tx_strdup.c:$(*))
-==$(*)== 	Address: 0x$(*)	size: 14	state: DIRTY
-==$(*)== [1]    at 0x$(*): __memcpy$(*)
-==$(*)==    by 0x$(*): constructor_tx_alloc (tx.c:$(*))
-==$(*)==    by 0x$(*): alloc_prep_block (palloc.c:$(*))
-==$(*)==    by 0x$(*): palloc_reservation_create (palloc.c:$(*))
-==$(*)==    by 0x$(*): palloc_reserve (palloc.c:$(*))
-==$(*)==    by 0x$(*): tx_alloc_common (tx.c:$(*))
-==$(*)==    by 0x$(*): pmemobj_tx_xwcsdup (tx.c:$(*))
-==$(*)==    by 0x$(*): do_tx_strdup_noflush (obj_tx_strdup.c:$(*))
-==$(*)==    by 0x$(*): main (obj_tx_strdup.c:$(*))
-==$(*)== 	Address: 0x$(*)	size: 56	state: DIRTY
-==$(*)== Total memory not made persistent: 70
-==$(*)== ERROR SUMMARY: 2 errors
+==$(*)== Number of stores not made persistent: 0
+==$(*)== ERROR SUMMARY: 0 errors
diff --git a/src/test/obj_tx_strdup/pmemcheck2.log.match b/src/test/obj_tx_strdup/pmemcheck2.log.match
new file mode 100644
index 00000000000..8805445e149
--- /dev/null
+++ b/src/test/obj_tx_strdup/pmemcheck2.log.match
@@ -0,0 +1,31 @@
+==$(*)== pmemcheck$(*)
+==$(*)== Copyright$(*)
+==$(*)== Using Valgrind-$(*)
+==$(*)== Command: ./obj_tx_strdup$(*)
+==$(*)== Parent PID: $(*)
+==$(*)== 
+==$(*)== 
+==$(*)== Number of stores not made persistent: 2
+==$(*)== Stores not made persistent properly:
+==$(*)== [0]    at 0x$(*): __memcpy$(*)
+==$(*)==    by 0x$(*): constructor_tx_alloc (tx.c:$(*))
+==$(*)==    by 0x$(*): alloc_prep_block (palloc.c:$(*))
+==$(*)==    by 0x$(*): palloc_reservation_create (palloc.c:$(*))
+==$(*)==    by 0x$(*): palloc_reserve (palloc.c:$(*))
+==$(*)==    by 0x$(*): tx_alloc_common (tx.c:$(*))
+==$(*)==    by 0x$(*): pmemobj_tx_xstrdup (tx.c:$(*))
+==$(*)==    by 0x$(*): do_tx_strdup_noflush (obj_tx_strdup.c:$(*))
+==$(*)==    by 0x$(*): main (obj_tx_strdup.c:$(*))
+==$(*)== 	Address: 0x$(*)	size: 14	state: DIRTY
+==$(*)== [1]    at 0x$(*): __memcpy$(*)
+==$(*)==    by 0x$(*): constructor_tx_alloc (tx.c:$(*))
+==$(*)==    by 0x$(*): alloc_prep_block (palloc.c:$(*))
+==$(*)==    by 0x$(*): palloc_reservation_create (palloc.c:$(*))
+==$(*)==    by 0x$(*): palloc_reserve (palloc.c:$(*))
+==$(*)==    by 0x$(*): tx_alloc_common (tx.c:$(*))
+==$(*)==    by 0x$(*): pmemobj_tx_xwcsdup (tx.c:$(*))
+==$(*)==    by 0x$(*): do_tx_strdup_noflush (obj_tx_strdup.c:$(*))
+==$(*)==    by 0x$(*): main (obj_tx_strdup.c:$(*))
+==$(*)== 	Address: 0x$(*)	size: 56	state: DIRTY
+==$(*)== Total memory not made persistent: 70
+==$(*)== ERROR SUMMARY: 2 errors
